//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
extern double Lots       =0.01;     //   . 
extern double Prots      =0.07;    //    
bool Work=true;                    //   .
string Symb;                       //  . 

extern int       StopLoss      =2000;     // SL   
extern int       TakeProfit    =800;      //     
extern int       Period_p      =10;
extern int       Period_m      =10;

int init()   { return(0); }
int deinit() { return(0); }
//--------------------------------------------------------------- 2 --
void start(void)
  {
   int
   Total,                           //     
   Tip=-1,                          //  .  (B=0,S=1)
   Ticket=0;                          //  
   double
   Lot=0,                             // .   .
   Lts,                             // .   .
   Min_Lot,                         //   
   Step,                            //    
   Free,                            //   
   One_Lot,                         //   
   SL,                              // SL   
   TP,                              // TP  
   Price;                           //   
   bool
   Ans  =false,                     //    
   Cls_B=false,                     //     Buy
   Cls_S=false,                     //     Sell
   Opn_B=false,                     //     Buy
   Opn_S=false;                     //     Sell
//--------------------------------------------------------------- 3 --
   // .
   if(Bars < 10){Alert("   .   .");return(0);}
   if(Work==false){Alert(" .   .");return(0);}
//--------------------------------------------------------------- 4 --
   //  
   Symb=Symbol();                               //  ..
   Total=0;                                     //  
   for(int i=1; i<=OrdersTotal(); i++)          //   
     {
      if (OrderSelect(i-1,SELECT_BY_POS)==true) //   
        {                                       //  :
         if (OrderSymbol()!=Symb)continue;      //   . 
         if (OrderType()>1){Alert("  .   .");return(0);}
         Total++;                               //  . 
         if (Total>1){Alert("  .   .");return(0);}
         Ticket=OrderTicket();                  //  . .
         Tip   =OrderType();                    //   .
         Price =OrderOpenPrice();               //  . .
         SL    =OrderStopLoss();                // SL  .
         TP    =OrderTakeProfit();              // TP  .
         Lot   =OrderLots();                    //  
        }
     }
//--------------------------------------------------------------- 5 --
static datetime t;
static datetime b;
static double Donchianp1,Donchianp2,Donchianm1,Donchianm2;
double r=AccountBalance();
double indicator=iCustom(NULL,0,"Balance",r,0,0);
if (Time[0]>t)
{
Donchianp1=iCustom(NULL,0,"ABC",Period_p,0,1);
Donchianp2=iCustom(NULL,0,"ABC",Period_p,0,2);
Donchianm1=iCustom(NULL,0,"ABC",Period_m,1,1);
Donchianm2=iCustom(NULL,0,"ABC",Period_m,1,2);
}
Donchianp1=iCustom(NULL,0,"ABC",Period_p,0,1);
if (Donchianp1 > Donchianp2 && Time[0] > b)Opn_B=true;
if (Donchianm1 < Donchianm2)Cls_B=true;
t=Time[0];
//--------------------------------------------------------------- 6 --
   //  
   while(true)                                  //   .
     {
      if (Tip==0 && Cls_B==true)                //   Buy..
        {                                       //   
         Alert("  Buy ",Ticket,".  ..");
         RefreshRates();                        //  
         Ans=OrderClose(Ticket,Lot,Bid,2);      //  Buy
         if (Ans==true){Alert ("  Buy ",Ticket);break;}
         if (Fun_Error(GetLastError())==1)      //  
            continue;                           //  
         return(0);                                //   start()
        }
      break;                                    //   while
     }
//--------------------------------------------------------------- 7 --
   //  
   RefreshRates();                              //  
   Min_Lot=MarketInfo(Symb,MODE_MINLOT);        // . .  
   Free   =AccountFreeMargin();                 //  
   One_Lot=MarketInfo(Symb,MODE_MARGINREQUIRED);//  1 
   Step   =MarketInfo(Symb,MODE_LOTSTEP);       //   

   if (Lots > 0)                                //   , 
      Lts =Lots;                                //     
   else                                         // %  
      Lts=MathFloor(Free*Prots/One_Lot/Step)*Step;//  

   if(Lts < Min_Lot) Lts=Min_Lot;               //   
   if (Lts*One_Lot > Free){Alert("     ", Lts," ");return(0);}
//--------------------------------------------------------------- 8 --
   //  
   while(true)                                  //   .
     {
      if (Total < 1 && Opn_B==true)              //  .  +
        {                                       //  . Buy
         RefreshRates();                        //  
         SL=Bid - New_Stop(StopLoss)*Point;     //  SL .
         TP=Bid + New_Stop(TakeProfit)*Point;   //  TP .
         Alert("  Buy.  ..");
         Ticket=OrderSend(Symb,OP_BUY,Lts,Ask,2,SL,TP);// Buy
         if (Ticket > 0)
         {
         Alert ("  Buy ",Ticket);
         b=Time[0];
         return(0);}
         if (Fun_Error(GetLastError())==1)      //  
            continue;                           //  
         return(0);                                //   start()
        }
      break;                                    //   while
     }
//--------------------------------------------------------------- 9 --
   return(0);                                      //   start()
  }
//-------------------------------------------------------------- 10 --
int Fun_Error(int Error)                        // -  
  {
   switch(Error)
     {                                          //              
      case  4: Alert("  .   ..");
         Sleep(3000);                           //  
         return(1);                             //   
      case 135:Alert(" .   ..");
         RefreshRates();                        //  
         return(1);                             //   
      case 136:Alert(" .   ..");
         while(RefreshRates()==false)           //   
            Sleep(1);                           //   
         return(1);                             //   
      case 137:Alert(" .   ..");
         Sleep(3000);                           //  
         return(1);                             //   
      case 146:Alert("  .  ..");
         Sleep(500);                            //  
         return(1);                             //   
         //  
      case  2: Alert(" .");
         return(0);                             //   
      case  5: Alert("  .");
         Work=false;                            //   
         return(0);                             //   
      case 64: Alert(" .");
         Work=false;                            //   
         return(0);                             //   
      case 133:Alert(" .");
         return(0);                             //   
      case 134:Alert("    .");
         return(0);                             //   
      default: Alert("  ",Error); //     
         return(0);                             //   
     }
  }
//-------------------------------------------------------------- 11 --
int New_Stop(int Parametr)                      //  -.
  {
   int Min_Dist=MarketInfo(Symb,MODE_STOPLEVEL);// . 
   if (Parametr<Min_Dist)                       //   .
     {
      Parametr=Min_Dist;                        //  .
      Alert("  -.");
     }
   return(Parametr);                            //  
  }
//-------------------------------------------------------------- 12 --
